#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <bios.h>
#include <dos.h>
#include <string.h>

#define WORD unsigned int
#define BYTE unsigned char
#define BOOL unsigned char
#define KEY	 unsigned char

#define CUP	 			0x4800
#define CDN	 			0x5000
#define CLI	 			0x4b00
#define CRE	 			0x4d00
#define	CR	 			0x1c0d
#define ESC	 			0x011b
#define KEINE_TASTE 	0xff


enum{FALSE, TRUE};

#define EDCURX	20
#define XO		5
#define YO		5
#define DELTAX	40
#define	DELTAY	5

typedef struct m{
		struct m *prev,				/*das vorhergehende men dieser ebene*/
				 *next;				/*das nchste men dieser ebene*/
		struct m *um;				/*untermen, falls vorhanden*/
		BYTE *mtxt;					/*mentext*/
		BYTE(*mfun)(struct m**,struct m**);/*menfunktion, falls vorhanden*/
		void *mdat;					/*mendaten, falls vorhanden*/
		BYTE(*tastfun[6])(struct m**,struct m**);/*tastenfunktionen*/
		}MENU;

typedef struct w{
		BYTE scrh;					/*fr die menanzeige nutzbare fensterhhe*/
		BYTE xo, yo, deltax, deltay;/*fensterkoordinaten*/
		MENU *m;					/*die aktuellen men*/
		}WIN;

BYTE curpos;
void menu(MENU *men);
BYTE curdwn(MENU **nz, MENU **cz);
BYTE curup(MENU **nz, MENU **cz);
BYTE dumfun(MENU **nz, MENU **cz);
BYTE submenu(MENU **nz, MENU **cz);
BYTE efun(MENU **nz, MENU **cz);
BYTE cur_aus(MENU **nz, MENU **cz);

/*die mendefinitionen beginnen mit dem men der untersten ebene*/
/* untermen 3 **************************************************************/
BYTE zeit[10];
BYTE uhrzeit(MENU **nz, MENU **cz);
MENU sm111[]={{&sm111[5],&sm111[1],NULL,"submenu1_1_1_1",dumfun,NULL,{curdwn,curup,dumfun,dumfun,dumfun,dumfun}},
			 {&sm111[0],&sm111[2],NULL,"submenu1_1_1_2",dumfun,NULL,{curdwn,curup,dumfun,dumfun,dumfun,dumfun}},
			 {&sm111[1],&sm111[3],NULL,"aktuelle zeit:",uhrzeit,zeit,{curdwn,curup,dumfun,dumfun,dumfun,dumfun}},
			 {&sm111[2],&sm111[4],NULL,"submenu1_1_1_4",dumfun,NULL,{curdwn,curup,dumfun,dumfun,dumfun,dumfun}},
			 {&sm111[3],&sm111[5],NULL,"submenu1_1_1_5",dumfun,NULL,{curdwn,curup,dumfun,dumfun,dumfun,dumfun}},
			 {&sm111[4],&sm111[0],NULL,"zurck",dumfun,NULL,{curdwn,curup,dumfun,dumfun,efun,dumfun}}};

/* untermen 2 **************************************************************/
#define EDFLEN 10
#define NUL "NULL"
BYTE efeld[EDFLEN]="test1", tefeld[EDFLEN];


BYTE edsubmenu(MENU **nz, MENU **cz);
BYTE edcurre(MENU **nz, MENU **cz);
BYTE edcurli(MENU **nz, MENU **cz);
BYTE edcurup(MENU **nz, MENU **cz);
BYTE edcurdn(MENU **nz, MENU **cz);
BYTE edesc(MENU **nz, MENU **cz);

MENU ef11[]={{&ef11[0],&ef11[0],NULL,"eingabe:",cur_aus,tefeld,{edcurdn,edcurup,edcurli,edcurre,efun,edesc}}};

MENU sm11[]={{&sm11[5],&sm11[1],NULL,"submenu1_1_1",dumfun,NULL,{curdwn,curup,dumfun,dumfun,dumfun,dumfun}},
			 {&sm11[0],&sm11[2],NULL,"submenu1_1_2",dumfun,NULL,{curdwn,curup,dumfun,dumfun,dumfun,dumfun}},
			 {&sm11[1],&sm11[3],ef11,"eingabefeld:",dumfun,efeld,{curdwn,curup,dumfun,dumfun,edsubmenu,dumfun}},
			 {&sm11[2],&sm11[4],NULL,"submenu1_1_4",dumfun,NULL,{curdwn,curup,dumfun,dumfun,dumfun,dumfun}},
			 {&sm11[3],&sm11[5],sm111,"zum Submen",dumfun,NULL,{curdwn,curup,dumfun,dumfun,submenu,dumfun}},
			 {&sm11[4],&sm11[0],NULL,"zurck",dumfun,NULL,{curdwn,curup,dumfun,dumfun,efun,dumfun}}};

/* unternen 1 **************************************************************/
MENU sm1[]={{&sm1[3],&sm1[1],NULL,"submenu1_1",dumfun,NULL,{curdwn,curup,dumfun,dumfun,dumfun,dumfun}},
			{&sm1[0],&sm1[2],sm11,"zum Submen",dumfun,NULL,{curdwn,curup,dumfun,dumfun,submenu,dumfun}},
			{&sm1[1],&sm1[3],NULL,"submenu1_3",dumfun,NULL,{curdwn,curup,dumfun,dumfun,dumfun,dumfun}},
			{&sm1[2],&sm1[0],NULL,"zurck",dumfun,NULL,{curdwn,curup,dumfun,dumfun,efun,dumfun}}};

/* das hauptmen ************************************************************/

MENU omu[]={{&omu[3],&omu[1],sm1,"zum Submen",dumfun,NULL,{curdwn,curup,dumfun,dumfun,submenu,dumfun}},
			{&omu[0],&omu[2],NULL,"menu2",dumfun,NULL,{curdwn,curup,dumfun,dumfun,dumfun,dumfun}},
			{&omu[1],&omu[3],NULL,"menu3",dumfun,NULL,{curdwn,curup,dumfun,dumfun,dumfun,dumfun}},
			{&omu[2],&omu[0],NULL,"ende ",dumfun,NULL,{curdwn,curup,dumfun,dumfun,efun,dumfun}}};

/* ende der mendefinitionen ***********************************************/


void dos_display(MENU *nz, MENU *cz);
void dos_win_open(void);
void dos_win_clear(void);
KEY dos_taste(void);


void main(void)
{
    clrscr();
	menu(omu);
	/*den gesamten bildschirm lschen*/
	window(0,0,80,25);
	clrscr();
}

void menu(MENU *men)
{   BYTE i;
	MENU *nullzeile, *curzeile;
	KEY t;
	BOOL ende=FALSE;

	nullzeile=curzeile=men;
	/*menfenster ffnen*/
	dos_win_open();

	while(!ende)
	{   /*das aktuelle fenster anzeigen*/

		dos_display(nullzeile,curzeile);
		/*tasten abfragen und ggf entsprechend reagieren*/
		if((t=dos_taste())!=KEINE_TASTE)
			ende=(BOOL)(*curzeile->tastfun[t])(&nullzeile,&curzeile);}

	/*aktuelles menfenster schlieen*/
}

void dos_win_open(void)
{	static char rah[]={'', '', '', '', '', ''};
    BYTE i, j;

	/*fenster ffnen und aktuellen bildschirminhalt retten*/
	window(XO,YO,XO+DELTAX,YO+DELTAY);
	/*puffer=(BYTE *)calloc(sizeof(BYTE), 2*(win->deltax+1)*(win->deltay+1));
    gettext(win->xo,win->yo,win->xo+win->deltax,win->yo+win->deltay, puffer);*/
	/*neues fenster 'subern' und textfarben einstellen*/
	clrscr();
	textcolor(WHITE); textbackground(BLACK);
	/*oberen fensterrahmen zeichnen*/
	gotoxy(1,1); cprintf("%c",rah[0]);
	for(i=1;i<DELTAX-1; i++)
		cprintf("%c", rah[5]);
	cprintf("%c",rah[1]);
	/*fensterbegrenzungen links und rechts zeichnen*/
	for(i=0; i<DELTAY; i++)
	{	gotoxy(1,i+2); cprintf("%c", rah[4]);
		gotoxy(DELTAX,i+2); cprintf("%c", rah[4]);}
	/*unteren fensterrahmen zeichnen*/
	gotoxy(1,DELTAY+1); cprintf("%c",rah[2]);
	for(i=1;i<DELTAX-1; i++)
		cprintf("%c", rah[5]);
	cprintf("%c",rah[3]);
	/*zeiger auf den letzten fensterinhalt zurckliefern*/
	/*return(puffer);*/
}
void dos_win_clear(void)
{	/*aktuellen fensterinhalt lschen*/
	window(XO+1,YO+1,XO+DELTAX-2,YO+DELTAY-1);
	clrscr();
	window(XO,YO,XO+DELTAX,YO+DELTAY);
}

void dos_display(MENU *nz, MENU *cz)
{   /*aktuelle menebene anzeigen*/
	BYTE i,displayzeile;
	MENU *menu;

	menu=nz;
	/*immer die menfunktionen der aktuellen menebene ausfhren*/
	while(menu->next!=nz)
	{	(*menu->mfun)((void*)0, &menu);
		menu=menu->next;}

	/*die menpunkte, die sich zwischen der ersten und der letzten*/
	/*displayzeile befinden, anzeigen. die darstellung wird mit */
	/*erreichen des letzten mens abgebrochen(also, falls es mehr*/
	/*fensterzeilen als menpunkte gibt)*/
	menu=nz;
	/*jede menzeile einzeln darstellen*/
	for(displayzeile=0;displayzeile<DELTAY-1; displayzeile++)
	{	gotoxy(2, displayzeile+2);
		/*cursorzeile kennzeichnen*/
		if(menu==cz&!(*cz->mfun)((void*)0,(void*)0))
		   	cprintf("%c", '*');
		/*restliche zeile auswerten*/
        gotoxy(3, displayzeile+2);
		cprintf("%s", menu->mtxt);
		if(menu->mdat!=NULL)
		{	gotoxy(EDCURX,displayzeile+2);
			cprintf("%s", menu->mdat);
			gotoxy(EDCURX+curpos,displayzeile+2);}

		if(menu->next==nz)
		/*beim erreichen der untersten displayzeile darstellung abbrechen*/
			break;
		/*sonst zur nchsten zeile weitergehen*/
		menu=menu->next;}
}

BYTE curdwn(MENU **nz, MENU **cz)
{   /*mennavigation nach unten*/
	/*bewegt den cursor bis zur untersten displayzeile. scrollt den */
	/*fensterinhalt nach erreichen dieser zeile nach oben oder setzt*/
	/*den cursor in die erste fensterzeile, falls das aktuelle men das*/
	/*fenster nicht ausfllt.*/

	MENU *z;
	BYTE i, displayzeile;

	dos_win_clear();
	/*cursor in nachfolgender zeile positionieren*/
	*cz=(*cz)->next;
	/*abstand zwischen 1.displayzeile und cursorzeile bestimmen*/
	z=(*nz);
	for(i=0; (*cz)!=z; i++)
		z=z->next;
    /*wenn der abstand grer als die fensterbreite ist, fensterinhalt*/
	/*eine zeile nach oben bewegen*/
	if(i>=DELTAY-1)
        *nz=(*nz)->next;
	return(FALSE);
}

BYTE curup(MENU **nz, MENU **cz)
{   /*mennavigation nach oben*/
	/*bewegt den cursor bis zur obersten displayzeile. scrollt den */
	/*fensterinhalt nach erreichen dieser zeile nach unten oder setzt*/
	/*den cursor auf den untersten menpunkt, falls das aktuelle men das*/
	/*fenster nicht ausfllt.*/

	MENU *z;
	BYTE i,displayzeile;

    dos_win_clear();
	/*cursor in vorhergehender zeile positionieren*/
    *cz=(*cz)->prev;
	/*abstand zwischen 1.displayzeile und cursorzeile bestimmen*/
    z=(*nz);
	for(i=0; (*cz)!=z; i++)
		z=z->next;
    /*wenn der abstand grer als die fensterbreite ist, fensterinhalt*/
	/*eine zeile nach unten bewegen, cursor in die 1.fensterzeile setzen*/
	if(i>=DELTAY-1)
	{	*nz=(*nz)->prev;
     	*cz=*nz;}
	return(FALSE);
}

KEY dos_taste(void)
{   /*umsetzung ausgewhlter tasten der pc-tastatur in array-index*/
	KEY taste=KEINE_TASTE;
	WORD i;

 	if(bioskey(1)!=0)
	{	i=bioskey(0);
		switch(i)
		{	case CUP:
         		taste=1;
				break;
			case CDN:
         		taste=0;
				break;
    		case CLI:
				taste=2;
				break;
			case CRE:
				taste=3;
				break;
			case CR:
				taste=4;
				break;
			case ESC:
				taste=5;
				break;}}
	return(taste);
}

BYTE efun(MENU **nz, MENU **cz)
{   /*beendet die arbeit mit der aktuellen menebene*/
	dos_win_clear();
 	return(TRUE);
}

BYTE dumfun(MENU **nz, MENU **cz)
{	/*dummyfunktion, tut nichts*/
	return(FALSE);
}

BYTE submenu(MENU **nz, MENU **cz)
{	/*leitet die arbeit mit einem untermen ein*/
	menu((*cz)->um);
	return(FALSE);
}


BYTE edsubmenu(MENU **nz, MENU **cz)
{	/*startet das edit-men*/
	/*prft, ob nderungen gespeichert werden sollen*/
    strcpy((*cz)->um->mdat,(*cz)->mdat);
	curpos=0;
	submenu(nz,cz);
	if(strcmp((*cz)->um->mdat, NUL)!=0)
		strcpy((*cz)->mdat,(*cz)->um->mdat);
	return(FALSE);
}


BYTE uhrzeit(MENU **nz, MENU **cz)
{	/*zeigt die rechnerzeit in der zugeordneten menzeile an*/
   struct  time t;

   gettime(&t);
   sprintf((*cz)->mdat,"%2d:%02d:%02d.%02d",
          t.ti_hour, t.ti_min, t.ti_sec, t.ti_hund);
   return(FALSE);
}

BYTE cur_aus(MENU **nz, MENU **cz)
{	/*cursor verbergen*/
	return(TRUE);
}

BYTE edcurre(MENU **nz, MENU **cz)
{	/*editcursor eine spalte nach rechts*/
 	if(curpos+1<EDFLEN)
		curpos+=1;
	return(FALSE);
}

BYTE edcurli(MENU **nz, MENU **cz)
{	/*editcursor eine spalte nach links*/
	if(curpos-1>=0)
		curpos-=1;
	return(FALSE);
}

BYTE edcurup(MENU **nz, MENU **cz)
{	/*der ascii-wert des zeichens an der cursorposition wird erhht*/
	if((*((BYTE*)(*cz)->mdat+curpos)>'z'+1)||(*((BYTE*)(*cz)->mdat+curpos)<'0'-1))
		*((BYTE*)(*cz)->mdat+curpos)='z';
	if(*((BYTE*)(*cz)->mdat+curpos)+1<'z'+1)
		*((BYTE*)(*cz)->mdat+curpos)+=1;
	return(FALSE);
}

BYTE edcurdn(MENU **nz, MENU **cz)
{	/*der ascii-wert des zeichens an der cursorposition wird erniedrigt*/
	if(*((BYTE*)(*cz)->mdat+curpos)<'0'-1)
		*((BYTE*)(*cz)->mdat+curpos)='0';
	if(*((BYTE*)(*cz)->mdat+curpos)-1>'0'-1)
		*((BYTE*)(*cz)->mdat+curpos)-=1;
 	return(FALSE);
}


BYTE edesc(MENU **nz, MENU **cz)
{	/*editmodus verlassen. nderungen werden verworfen*/
	memset((*cz)->mdat, 0,EDFLEN);
    strcpy((*cz)->mdat,NUL);
	return(TRUE);
}